
// Include-Dateien
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>

// Typdeklarationen
struct stackElem {
	int Element;
   struct stackElem *next;
   };

typedef struct stackElem t_StackElem;

typedef struct {
	t_StackElem *top;
   int size;
   } t_stack;

// Globale Variablen
// t_StackElem *top = NULL;

// Prototypen
void push(int Element, t_stack *s);
int pop(t_stack *s);
void init(t_stack *s);

main()
{
   t_stack stack1, stack2;

   init(&stack1);
   init(&stack2);

   int a;
   a = pop(&stack1);
   push(7, &stack1);
   push(5, &stack1);
   push(3, &stack2);

   printf("Size Stack 1: %d \n",stack1.size);
   printf("Size Stack 2: %d \n",stack2.size);

   a = pop(&stack1);
	printf("%d \n",a);


   a = pop(&stack2);
	printf("%d \n",a);

   a = pop(&stack1);
	printf("%d \n",a);

   a = pop(&stack1);
	printf("%d \n",a);

   getch();
}

void push(int Element, t_stack *s)
{
   t_StackElem *neu;

	neu = (t_StackElem *) malloc(sizeof(t_StackElem)); // Neues Stack-Element besorgen

   if (neu != NULL)
   {
		neu->Element = Element; // Inhalt in Stack-Element kopieren

   	neu->next = s->top; // Stack-Element in Stack einfgen
		s->top = neu;
	   s->size = s->size + 1;
   }
   else
   	printf("Fehler in push() bei malloc!\n");
}

int pop(t_stack *s)
{
	int erg=0;
   t_StackElem *alt = s->top;
   if (s->top != NULL) // Stack leer ???
   {
   	erg = s->top->Element; // Inhalt Oberstes Stack-Element nach erg kopieren
   	s->top = s->top->next; // top aktualisieren
      s->size = s->size - 1;
   	free(alt); //Speicherplatz freigeben
   }
   else
   	printf("Fehler in pop(): Stack leer!\n");

   return erg;
}

void init(t_stack *s)
{
   // s.top = NULL;
   s->top = NULL;  // (*s).top = NULL;
   s->size = 0;
}
