#include <stdio.h>
#include <conio.h>
#include <time.h>

#define MAX 10000

void swap(int *a, int *b);

void bubblesort(int z[MAX], int anzahl);



main()
{
    int feld[MAX], i=0;
    int anzsort;
    FILE *fp;
    time_t *programmstart = (time_t *) malloc(sizeof(time_t));
    time_t *programmende = (time_t *) malloc(sizeof(time_t));
    time_t *voreinlesen = (time_t *) malloc(sizeof(time_t));
    time_t *nacheinlesen = (time_t *) malloc(sizeof(time_t));
    time_t *vorsortieren = (time_t *) malloc(sizeof(time_t));
    time_t *nachsortieren = (time_t *) malloc(sizeof(time_t));
    time_t *vorschreiben = (time_t *) malloc(sizeof(time_t));
    time_t *nachschreiben = (time_t *) malloc(sizeof(time_t));
    
    
    time(programmstart);  //systemzeit auf null setzen
    
    //daten einlesen
    if((fp = fopen("tosort.txt", "r")) != NULL)
    {
        fscanf(fp, "%d", &anzsort);
        time(voreinlesen);
        while( fscanf(fp, "%d", &feld[i]) != EOF )
            i++;
        time(nacheinlesen);
    }
    fclose(fp);
    
    //daten sortieren
    time(vorsortieren);
    bubblesort(feld, anzsort);
    time(nachsortieren);
    
    //daten schreiben
    i=0;
    if((fp = fopen("sorted.txt", "w")) != NULL)
    {
        time(vorschreiben);
        
        while( i < anzsort )
        {
            fprintf(fp, "%d\n", feld[i]);
            i++;
        }
        
        time(nachschreiben);
    }
    fclose(fp);
    
    time(programmende);     //systemzeit abfragen
    
    printf("Einlesen: %f sec\n", difftime(*nacheinlesen, *voreinlesen));
    printf("Sortieren: %f sec\n", difftime(*nachsortieren, *vorsortieren));
    printf("Schreiben: %f sec\n", difftime(*nachschreiben, *vorschreiben));
    printf("Insgesammt: %f sec\n", difftime(*programmende, *programmstart));
    getch();
}



void bubblesort(int z[MAX], int anzahl)
{
    int i;
    
    //nur ntig, wenn mindestens zwei elemente verglichen werden knnen
    if(anzahl > 1)
    {
        //grtes element nach hinten schieben
        for (i=0; i<anzahl-1; i++)
            if (z[i]>z[i+1])
                swap(&z[i],&z[i+1]);
        
        //rekursion
        bubblesort(z, anzahl-1);
    }
}


void swap(int *a, int *b)
{
    int temp = *a;
    *a = *b;
    *b = temp;
}

