#include <stdio.h>
#include <conio.h>

#define NX 50
#define NY 50
#define DAME -1

int damen(int anzahl, int feld[NX][NY], int dimX, int dimY);

void setzeDame(int posX, int posY, int feld[NX][NY], int dimX, int dimY);

void loescheDame(int posX, int posY, int feld[NX][NY], int dimX, int dimY);

void init(int feld[NX][NY], int dimX, int dimY);

void ausgabe(int feld[NX][NY], int dimX, int dimY);

int main()
{
	int feld[NX][NY];

   int anzahl, dimX, dimY;

   printf("Wie gross soll das Feld sein (x,y)?\n");
   scanf("%d %d", &dimX, &dimY);

   init(feld, dimX, dimY);

/*   setzeDame(3,5,feld,dimX,dimY);
   setzeDame(5,2,feld,dimX,dimY);
   ausgabe(feld,dimX,dimY);
   getch();
   loescheDame(3,5,feld,dimX,dimY);
   ausgabe(feld,dimX,dimY);   */

   printf("Anzahl der Damen?\n");
   scanf("%d", &anzahl);

   if ( damen(anzahl, feld, dimX, dimY))
   	ausgabe(feld, dimX, dimY);
   else
   	printf("Keine Lsung gefunden!\n");
   getch();
}

void init(int feld[NX][NY], int dimX, int dimY)
{
	int i, j;

   for(i=0; i < dimX; ++i)
   	for(j=0; j < dimY; ++j)
      	feld[i][j] = 0;
}

void ausgabe(int feld[NX][NY], int dimX, int dimY)
{
	int i, j;

   for(i=0; i < dimY; ++i)
   {
   	for(j=0; j < dimX; ++j)
      	printf("%2d ",feld[i][j]);
      printf("\n");
   }
//      	if (feld[i][j] == DAME)
//         	printf("Dame bei: %d %d\n",i+1,j+1);
}

int damen(int anzahl, int feld[NX][NY], int dimX, int dimY)
{
	int erg=0;
   int x=0,y=0;

   if (anzahl > 0)
   {
      while (erg==0 && y<dimY)
      {
      	while (erg==0 && x<dimX)
         {
         if (feld[x][y] == 0)
         {
         	setzeDame(x,y,feld,dimX,dimY);
            if (damen(anzahl-1,feld,dimX,dimY))
            {
            	erg = 1;
            }
            else
            {
            	loescheDame(x,y,feld,dimX,dimY);
            }
         }
         ++x;
         }
         x=0;
         ++y;
      }
   }
   else
   	erg = 1;

   return erg;
}

void setzeDame(int posX, int posY, int feld[NX][NY], int dimX, int dimY)
{
	int x,y;

	for (x=0; x<dimX; ++x)
   	++feld[x][posY];

   for (y=0; y < dimY; ++y)
   	++feld[posX][y];

   x=posX;
   y=posY;
   while (y>=0 && x<dimX)
   {
   	++feld[x][y];
      ++x;
      --y;
   }

   x=posX;
   y=posY;
   while (y<dimY && x<dimX)
   {
   	++feld[x][y];
      ++x;
      ++y;
   }

   x=posX;
   y=posY;
   while (y>=0 && x>=0)
   {
   	++feld[x][y];
      --x;
      --y;
   }

   x=posX;
   y=posY;
   while (y<dimY && x>=0)
   {
   	++feld[x][y];
      --x;
      ++y;
   }

	feld[posX][posY] = DAME;
}

void loescheDame(int posX, int posY, int feld[NX][NY], int dimX, int dimY)
{
	int x,y;

	for (x=0; x<dimX; ++x)
   	--feld[x][posY];

   for (y=0; y < dimY; ++y)
   	--feld[posX][y];

   x=posX;
   y=posY;
   while (y>=0 && x<dimX)
   {
   	--feld[x][y];
      ++x;
      --y;
   }

   x=posX;
   y=posY;
   while (y<dimY && x<dimX)
   {
   	--feld[x][y];
      ++x;
      ++y;
   }

   x=posX;
   y=posY;
   while (y>=0 && x>=0)
   {
   	--feld[x][y];
      --x;
      --y;
   }

   x=posX;
   y=posY;
   while (y<dimY && x>=0)
   {
   	--feld[x][y];
      --x;
      ++y;
   }

	feld[posX][posY] = 0;
}





