
#ifndef __fahrzeuge
#define __fahrzeuge


#include <iostream>
using namespace std;

/*fr Borland5
#inlcude <iostream.h>
*/


/////////////////////////// Fahrzeuge //////////////////////////////////

class Fahrzeug {
    protected:
        int tageskosten;
        int baujahr;
        int verfuegbar;
    public:
        char name[30];
        Fahrzeug()
        {
            verfuegbar = 1;
            
            cout << "Fahrzeugname: ";
            cin >> name;
            cout << "Kosten: ";
            cin >> tageskosten;
            cout << "Baujahr: ";
            cin >> baujahr;
        }
        virtual void aendern(void)
        {
            cout << "\nBitte aktualisierte Daten fuer " << name << " eingeben:\n\n";
            
            cout << "Kosten: ";
            cin >> tageskosten;
        }
        virtual void ausgabe(void)
        {
            cout << "\tFahrzeugname: " << name << "\n";
            cout << "\tKosten: " << tageskosten << "\n";
            cout << "\tBaujahr: " << baujahr << "\n";
        }
        int ist_verfuegbar(void)
        {
            return verfuegbar; 
        }
        void verleihen()
        {
            if( verfuegbar ) verfuegbar = 0;
            else cerr << "Fahrzeug leider nicht verfuegbar!\n";
        }
        void rueckgabe()
        {
            verfuegbar = 1;
            cout << "Fehrzeugrueckgabe\n";
        }
};




///////////////////////////////// PKWs //////////////////////////////

class PKW : public Fahrzeug {
    protected:
        int ps;
        int spitze;
        int sitzplaetze;
    public:
        PKW()
        {
            cout << "PS: ";
            cin >> ps;
            cout << "Hoechstgeschwindigkeit: ";
            cin >> spitze;
            cout << "Sitzplaetze: ";
            cin >> sitzplaetze;
        }
        void aendern(void)
        {
            Fahrzeug::aendern();
            cout << "PS: ";
            cin >> ps;
            cout << "Hoechstgeschwindigkeit: ";
            cin >> spitze;
            cout << "Sitzplaetze: ";
            cin >> sitzplaetze;
        }
        void ausgabe(void)
        {
            Fahrzeug::ausgabe();
            cout << "\tPS: " << ps << "\n";
            cout << "\tHoechstgeschwindigkeit: " << spitze << "\n";
            cout << "\tSitzplaetze: " << sitzplaetze << "\n";
        }
};



////////////////// spezielle PKWs ///////////////////////////////

class Cabrio : public PKW {
    protected:
        char verdeckart[30];
    public:
        Cabrio()
        {
            cout << "Verdeckart (elektrisch-manuell): ";
            cin >> verdeckart;
        }
        void aendern(void)
        {
            PKW::aendern();
            cout << "Verdeckart (elektrisch-manuell): ";
            cin >> verdeckart;
        }
        void ausgabe(void)
        {
            PKW::ausgabe();
            cout << "\tVerdeckart: " << verdeckart << "\n";
        }
};

class Limo : public PKW {
    protected:
        int minibars;
    public:
        Limo()
        {
            cout << "Minibars: ";
            cin >> minibars;
        }
        void aendern(void)
        {
            PKW::aendern();
            cout << "Minibars: ";
            cin >> minibars;
        }
        void ausgabe(void)
        {
            PKW::ausgabe();
            cout << "\tMinibars: " << minibars << "\n";
        }
};

class Kombi : public PKW {
    protected:
        int stauraum;
    public:
        Kombi()
        {
            cout << "Kofferraumvolumen: ";
            cin >> stauraum;
        }
        void aendern(void)
        {
            PKW::aendern();
            cout << "Kofferraumvolumen: ";
            cin >> stauraum;
        }
        void ausgabe(void)
        {
            PKW::ausgabe();
            cout << "\tKofferraumvolumen: " << stauraum << "\n";
        }
};

class Bus : public PKW {
    protected:
        int schiebetueren;
        int schlafplaetze;
    public:
        Bus()
        {
            cout << "Schiebetueren: ";
            cin >> schiebetueren;
            cout << "Schlafplaetze: ";
            cin >> schlafplaetze;
        }
        void aendern(void)
        {
            PKW::aendern();
            cout << "Schiebetueren: ";
            cin >> schiebetueren;
            cout << "Schlafplaetze: ";
            cin >> schlafplaetze;
        }
        void ausgabe(void)
        {
            PKW::ausgabe();
            cout << "\tSchiebetueren: " << schiebetueren << "\n";
            cout << "\tSchlafplaetze: " << schlafplaetze << "\n";
        }
};




////////////////////////////// LKWs ////////////////////////


class LKW : public Fahrzeug {
    protected:
        int ps;
        int achsen;
        int zuladung;
    public:
        LKW()
        {
            cout << "PS:";
            cin >> ps;
            cout << "Achsen:";
            cin >> achsen;
            cout << "Zuladung:";
            cin >> zuladung;
        }
        void aendern(void)
        {
            Fahrzeug::aendern();
            cout << "PS:";
            cin >> ps;
            cout << "Zuladung:";
            cin >> zuladung;
        }
        void ausgabe(void)
        {
            Fahrzeug::ausgabe();
            cout << "\tPS: " << ps << "\n";
            cout << "\tAchsen: " << achsen << "\n";
            cout << "\tZuladung: " << zuladung << "\n";
        }
};







////////////////////////// Anhnger ////////////////////////



class Anhaenger : public Fahrzeug {
    protected:
        int zuladung;
    public:
        Anhaenger()
        {
            cout << "Zuladung: ";
            cin >> zuladung;
        }
        void aendern(void)
        {
            Fahrzeug::aendern();
            cout << "Zuladung: ";
            cin >> zuladung;
        }
        void ausgabe(void)
        {
            Fahrzeug::ausgabe();
            cout << "\tZuladung: " << zuladung << "\n";
        }
};






//////////////////////////// spezielle Anhnger /////////////////////////////


class LKW_Anhaenger : public Anhaenger {
    protected:
        int achsen;
    public:
        LKW_Anhaenger()
        {
            cout << "Achsen:";
            cin >> achsen;
        }
        void aendern(void)
        {
            Anhaenger::aendern();
        }
        void ausgabe(void)
        {
            Anhaenger::ausgabe();
            cout << "\tAchsen: " << achsen << "\n";
        }
};



class PKW_Anhaenger : public Anhaenger {
    protected:
        char bremse[8];
    public:
        PKW_Anhaenger()
        {
            cout << "Bremsverstaerkung (ja/nein): ";
            cin >> bremse;
        }
        void aendern(void)
        {
            Anhaenger::aendern();
            cout << "Bremsverstaerkung (ja/nein): ";
            cin >> bremse;
        }
        void ausgabe(void)
        {
            Anhaenger::ausgabe();
            cout << "\tBremsverstaerkung: " << bremse << "\n";
        }
};



//////////////////////////// spezieller PKW_Anhnger //////////////////

class Wohnwagen : public PKW_Anhaenger {
    protected:
        int schlafplaetze;
        int herdplatten;
    public:
        Wohnwagen()
        {
            cout << "Schlafplaetze:";
            cin >> schlafplaetze;
            cout << "Herdplatten:";
            cin >> herdplatten;
        }
        void aendern(void)
        {
            PKW_Anhaenger::aendern();
            cout << "Schlafplaetze:";
            cin >> schlafplaetze;
            cout << "Herdplatten:";
            cin >> herdplatten;
        }
        void ausgabe(void)
        {
            PKW_Anhaenger::ausgabe();
            cout << "\tSchlafplaetze:  " << schlafplaetze << "\n";
            cout << "\tHerdplatten:    " << herdplatten << "\n";
        }
};


#endif
