/* sortiert ber tastatur eingegebene integerwerte */
/* aufsteigend und speichert diese in sortiert.txt */


#include <stdio.h>
#include <conio.h>
#include <dos.h>

void quicksort(int v[], int left, int right);
void swap(int v[], int i, int j);

main()
{
    int i=0, v[1000], c=1;
    FILE *stat;
    
    printf("Zahlen eingeben. 0 beendet eingabe\n");
    while(c != 0)
    {
        scanf("%d", &c);
        v[i++] = c;
    }
    quicksort(v, 0, i-2);
    i = 0;
    printf("sortiert:\n");
    while (v[i] != 0)
    {
        printf("%d\t", v[i++]);
    }
    
    if ((stat = fopen("sortiert.txt", "w")) != NULL)
    {
   	    i = 0;
   	    fprintf(stat, "sortiert:\n");
   	    while (v[i] != 0)
       	{
             fprintf(stat, "%d\n", v[i++]);
        }
    }
    else
      	printf("Fehler beim erzeugen oder beschreiben der Datei statistik.txt\n");
    
    printf("\nende\n");
    fclose(stat);
    getch();
}

void quicksort(int v[], int left, int right)
{
    int i, last, k;

    if (left >= right)
        return;
    swap(v, left, (left + right)/2);
    last = left;
    for (i = left+1; i <= right; i++)
        if (v[i] < v[left])
            swap(v, ++last, i);
    swap(v, left, last);
    quicksort(v, left, last-1);
    quicksort(v, last+1, right);
}

void swap(int v[], int i, int j)
{
    int temp;
   
    temp = v[i];
    v[i] = v[j];
    v[j] = temp;
}
